// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.administration.programStrategy;

/**
 * <p>
 * Programme d'observation à l'origine d'une collecte de données.
 * </p>
 * <p>
 * Désigne les activités qui sont à l'origine de la collecte d'un
 * ensemble cohérent de données, que ce soit pour des collectes
 * continues (marées observées en mer, SIPA) ou pour des études
 * limitées dans le temps. La quantité de données rattachées à un
 * programme peut être variable, selon qu'il s'agit d'une activité
 * longue ou intensive, ou d'une opération plus ponctuelle (étude)
 * mais toujours mise en œuvre selon un schéma décidé à l'avance.
 * </p>
 * <p>
 * Exemple de programmes d'observations :
 * </p>
 * <p>
 * - SIH-OBSMER (marées observées en mer)
 * </p>
 * <p>
 * - SIH-STATPECHE (enquete d'activité et d'effort...)
 * </p>
 * <p>
 * - SIPA : données déclaratives transmises par la DPMA
 * </p>
 * <p>
 * - VMS : données satellitaires
 * </p>
 * <p>
 * - OFIMER : données du SI de l'OFIMER
 * </p>
 */
public abstract class Program
    implements java.io.Serializable
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -8923218287399812385L;

    private java.lang.String code;

    /**
     * 
     */
    public java.lang.String getCode()
    {
        return this.code;
    }

    public void setCode(java.lang.String code)
    {
        this.code = code;
    }

    private java.lang.String name;

    /**
     * 
     */
    public java.lang.String getName()
    {
        return this.name;
    }

    public void setName(java.lang.String name)
    {
        this.name = name;
    }

    private java.lang.String description;

    /**
     * 
     */
    public java.lang.String getDescription()
    {
        return this.description;
    }

    public void setDescription(java.lang.String description)
    {
        this.description = description;
    }

    private java.util.Date creationDate;

    /**
     * 
     */
    public java.util.Date getCreationDate()
    {
        return this.creationDate;
    }

    public void setCreationDate(java.util.Date creationDate)
    {
        this.creationDate = creationDate;
    }

    private java.sql.Timestamp updateDate;

    /**
     * 
     */
    public java.sql.Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    public void setUpdateDate(java.sql.Timestamp updateDate)
    {
        this.updateDate = updateDate;
    }































    private java.util.Collection<fr.ifremer.adagio.core.dao.referential.location.LocationClassification> locationClassifications = new java.util.HashSet<fr.ifremer.adagio.core.dao.referential.location.LocationClassification>();

    /**
     * <p>
     * Classifications de lieu concernés par le programme.
     * </p>
     * <p>
     * Au moins une est obligatoire.
     * </p>
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.referential.location.LocationClassification> getLocationClassifications()
    {
        return this.locationClassifications;
    }

    public void setLocationClassifications(java.util.Collection<fr.ifremer.adagio.core.dao.referential.location.LocationClassification> locationClassifications)
    {
        this.locationClassifications = locationClassifications;
    }


    private fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroupType taxonGroupType;

    /**
     * <p>
     * Type de classification d'espèce commerciales utilisé par le
     * programme.
     * </p>
     * <p>
     * Généralement, pour les actions du SIH, on utilise le référentiel
     * des espèces commerciales ASFIS/FAO.
     * </p>
     * <p>
     * Malgré tout, dans certains cas (ex : données historiques),
     * d'autres référentiels peuvent avoir été utilisés.
     * </p>
     */
    public fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroupType getTaxonGroupType()
    {
        return this.taxonGroupType;
    }

    public void setTaxonGroupType(fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroupType taxonGroupType)
    {
        this.taxonGroupType = taxonGroupType;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.administration.programStrategy.Program2Department> program2Departments = new java.util.HashSet<fr.ifremer.adagio.core.dao.administration.programStrategy.Program2Department>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.administration.programStrategy.Program2Department> getProgram2Departments()
    {
        return this.program2Departments;
    }

    public void setProgram2Departments(java.util.Collection<fr.ifremer.adagio.core.dao.administration.programStrategy.Program2Department> program2Departments)
    {
        this.program2Departments = program2Departments;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.administration.programStrategy.Strategy> strategies = new java.util.HashSet<fr.ifremer.adagio.core.dao.administration.programStrategy.Strategy>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.administration.programStrategy.Strategy> getStrategies()
    {
        return this.strategies;
    }

    public void setStrategies(java.util.Collection<fr.ifremer.adagio.core.dao.administration.programStrategy.Strategy> strategies)
    {
        this.strategies = strategies;
    }


    private fr.ifremer.adagio.core.dao.referential.gear.GearClassification gearClassification;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.referential.gear.GearClassification getGearClassification()
    {
        return this.gearClassification;
    }

    public void setGearClassification(fr.ifremer.adagio.core.dao.referential.gear.GearClassification gearClassification)
    {
        this.gearClassification = gearClassification;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.referential.location.Location> locations = new java.util.HashSet<fr.ifremer.adagio.core.dao.referential.location.Location>();

    /**
     * <p>
     * Lieux concernés par le programme.Les lieux sont obligatoirement
     * du type de lieu rattaché au programme (cf. type de lieu
     * concerné).
     * </p>
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.referential.location.Location> getLocations()
    {
        return this.locations;
    }

    public void setLocations(java.util.Collection<fr.ifremer.adagio.core.dao.referential.location.Location> locations)
    {
        this.locations = locations;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.administration.programStrategy.Program2Person> programUsers = new java.util.HashSet<fr.ifremer.adagio.core.dao.administration.programStrategy.Program2Person>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.administration.programStrategy.Program2Person> getProgramUsers()
    {
        return this.programUsers;
    }

    public void setProgramUsers(java.util.Collection<fr.ifremer.adagio.core.dao.administration.programStrategy.Program2Person> programUsers)
    {
        this.programUsers = programUsers;
    }





    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Program))
        {
            return false;
        }
        final Program that = (Program)object;
        if (this.code == null || that.getCode() == null || !this.code.equals(that.getCode()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (code == null ? 0 : code.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link fr.ifremer.adagio.core.dao.administration.programStrategy.Program}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.administration.programStrategy.Program}.
         */
        public static fr.ifremer.adagio.core.dao.administration.programStrategy.Program newInstance()
        {
            final fr.ifremer.adagio.core.dao.administration.programStrategy.Program entity = new fr.ifremer.adagio.core.dao.administration.programStrategy.ProgramImpl();
			return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.administration.programStrategy.Program}, taking all required and/or
         * read-only properties as arguments.
         */
        public static fr.ifremer.adagio.core.dao.administration.programStrategy.Program newInstance(java.lang.String name, java.lang.String description, java.util.Date creationDate, java.util.Collection<fr.ifremer.adagio.core.dao.referential.location.LocationClassification> locationClassifications, fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroupType taxonGroupType, fr.ifremer.adagio.core.dao.referential.gear.GearClassification gearClassification)
        {
            final fr.ifremer.adagio.core.dao.administration.programStrategy.Program entity = newInstance();
            entity.setName(name);
            entity.setDescription(description);
            entity.setCreationDate(creationDate);
            entity.setLocationClassifications(locationClassifications);
            entity.setTaxonGroupType(taxonGroupType);
            entity.setGearClassification(gearClassification);
            return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.administration.programStrategy.Program}, taking all possible properties
         * (except the identifier(s))as arguments.
         */
        public static fr.ifremer.adagio.core.dao.administration.programStrategy.Program newInstance(java.lang.String name, java.lang.String description, java.util.Date creationDate, java.sql.Timestamp updateDate, java.util.Collection<fr.ifremer.adagio.core.dao.referential.location.LocationClassification> locationClassifications, fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroupType taxonGroupType, java.util.Collection<fr.ifremer.adagio.core.dao.administration.programStrategy.Program2Department> program2Departments, java.util.Collection<fr.ifremer.adagio.core.dao.administration.programStrategy.Strategy> strategies, fr.ifremer.adagio.core.dao.referential.gear.GearClassification gearClassification, java.util.Collection<fr.ifremer.adagio.core.dao.referential.location.Location> locations, java.util.Collection<fr.ifremer.adagio.core.dao.administration.programStrategy.Program2Person> programUsers)
        {
            final fr.ifremer.adagio.core.dao.administration.programStrategy.Program entity = newInstance();
            entity.setName(name);
            entity.setDescription(description);
            entity.setCreationDate(creationDate);
            entity.setUpdateDate(updateDate);
            entity.setLocationClassifications(locationClassifications);
            entity.setTaxonGroupType(taxonGroupType);
            entity.setProgram2Departments(program2Departments);
            entity.setStrategies(strategies);
            entity.setGearClassification(gearClassification);
            entity.setLocations(locations);
            entity.setProgramUsers(programUsers);
            return entity;
        }
    }
    
// Program.java merge-point
}